package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ᥽åɤΰǤ

   paramǤбޤ
*/
public class MethodParameter extends Parameter {

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       ؿΰޤ

       @param g 롼
       @param elem parameter
    */
    public MethodParameter(final Group g, final Element elem) {
	IDManager id = IDManager.getInstance();
	type = g.expandAT(elem, "type");
	name = id.getIDAttribute(elem, "name");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}

       type°#ޤޤ硢Ƭ#name°Ƥִ
       Τ֤ޤǤʤСtype°name°Ƥ
       Ϣ뤷Τ֤ޤ
    */
    @Override public String getCode() {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return type.substring(0, k) + name + type.substring(k + 1);
	} else {
	    return type + " " + name;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getName() {
	return name;
    }

    /**
       {@inheritDoc}
    */
    @Override public String getHTML(final Group g) {
	String argName = "<i>" + name + "</i>";
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return g.getHTML(type.substring(0, k))
		+ argName
		+ g.getHTML(type.substring(k + 1));
	} else {
	    return g.getHTML(type) + "&nbsp;" + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getTEX(final Group g) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return g.getTEX(type.substring(0, k))
		+ argName
		+ g.getTEX(type.substring(k + 1));
	} else {
	    return g.getTEX(type) + " " + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<i>" + name + "</i> - " + desc.getText() + "<br>\n");
   }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";

	wr.println(""
+ "\\item[" + argName + "] " + desc.getTexText());
   }

}
