package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ޥΥåȤǤ
*/
public class Macros {

    /** ޥΥꥹ */
    private LinkedList<Macro> v;

    /**
       ޥΥåȤޤ

       @param g 롼
       @param nodes memberǤΥΡɥꥹ
    */
    public Macros(final Group g, final NodeList nodes) {
	v = new LinkedList<Macro>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    Macro m = new Macro(g, elem);
	    g.addKeyword(m.getName());
	    v.add(m);
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (Macro m : v) {
	    m.printCode(wr);
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println(""
+ "    <h2>Macro Summary</h2>\n"
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");

	for (Macro m : v) {
	    m.printSummary(wr);
	}

	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println(""
+ "    <h2>Macro Detail</h2>");

	for (Macro m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("\\Smacro");

	for (Macro m : v) {
	    m.printTexDetail(wr);
	}
    }
}
