package com.maroontress.sanctuary;

import java.util.HashMap;

/**
   ̾Ǥ

   ̾ˤбά̾¸ߤޤ
*/
public final class QualifiedName {

    /** ִ̾ʸפȡִ̾פΥޥå */
    private static HashMap<String, QualifiedName> map;

    /** ̾ */
    private String qualified;

    /** ά̾ */
    private String simple;

    static {
        map = new HashMap<String, QualifiedName>();
    }

    /**
       ̾ޤ

       @param qualified ʸ
       @param simple άʸ
    */
    private QualifiedName(final String qualified, final String simple) {
	this.qualified = qualified;
	this.simple = simple;
    }

    /**
       ̾ޤ

       @param qualified ʸ
       @param simple άʸ
       @return ̾
    */
    public static QualifiedName intern(final String qualified,
				       final String simple) {
	String q = qualified.intern();
	String s = simple.intern();
	QualifiedName m;
	if ((m = map.get(q)) != null) {
	    /* m.simplesimpleۤʤϤɤ? Ȥꤢ̵ */
	    return m;
	}
	m = new QualifiedName(q, s);
	map.put(q, m);
	return m;
    }

    /**
       ȴά̾ޤ

       @param s ʸ
       @return ̾
    */
    public static QualifiedName intern(final String s) {
	return QualifiedName.intern(s, s);
    }

    /**
       Ƭꤷƴ̾ޤ

       @param prefix Ƭ
       @param s ̾
       @return ̾
    */
    public static QualifiedName prepend(final String prefix,
					final QualifiedName s) {
	return QualifiedName.intern(prefix + s.qualified, prefix + s.simple);
    }

    /**
       ꤷƴ̾ޤ

       @param s ̾
       @param suffix 
       @return ̾
    */
    public static QualifiedName append(final QualifiedName s,
				       final String suffix) {
	return QualifiedName.intern(s.qualified + suffix, s.simple + suffix);
    }

    /**
       ʸޤ

       @return ʸ
    */
    public String getQualified() {
	return qualified;
    }

    /**
       άʸޤ

       @return άʸ
    */
    public String getSimple() {
	return simple;
    }

    /**
       {@inheritDoc}

       ʸޤ
    */
    @Override public String toString() {
	return qualified;
    }
}
